"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComputeBooleanNode = void 0;
var core_1 = require("@compute.ts/core");
var ComputeBooleanLibrary_1 = require("./ComputeBooleanLibrary");
var ComputeBooleanNode = /** @class */ (function (_super) {
    __extends(ComputeBooleanNode, _super);
    function ComputeBooleanNode(children, evalFn, value) {
        if (children === void 0) { children = []; }
        return _super.call(this, children, evalFn, value) || this;
    }
    ComputeBooleanNode.leaf = function (value) {
        return new ComputeBooleanNode([], undefined, value);
    };
    ComputeBooleanNode.expression = function (children, evalFn) {
        if (children === void 0) { children = []; }
        return new ComputeBooleanNode(children, evalFn);
    };
    ComputeBooleanNode.nodify = function (input) {
        var output = [];
        for (var _i = 0, input_1 = input; _i < input_1.length; _i++) {
            var value = input_1[_i];
            if (typeof value == 'boolean') {
                var node = ComputeBooleanNode.leaf(value);
                output.push(node);
            }
            else {
                output.push(value);
            }
        }
        return output;
    };
    ComputeBooleanNode.prototype.and = function () {
        var input = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            input[_i] = arguments[_i];
        }
        return ComputeBooleanLibrary_1.and.apply(void 0, __spreadArrays([this], input));
    };
    ComputeBooleanNode.prototype.or = function () {
        var input = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            input[_i] = arguments[_i];
        }
        return ComputeBooleanLibrary_1.or.apply(void 0, __spreadArrays([this], input));
    };
    ComputeBooleanNode.prototype.xand = function () {
        var input = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            input[_i] = arguments[_i];
        }
        return ComputeBooleanLibrary_1.xand.apply(void 0, __spreadArrays([this], input));
    };
    ComputeBooleanNode.prototype.xor = function () {
        var input = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            input[_i] = arguments[_i];
        }
        return ComputeBooleanLibrary_1.xor.apply(void 0, __spreadArrays([this], input));
    };
    ComputeBooleanNode.prototype.nand = function () {
        var input = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            input[_i] = arguments[_i];
        }
        return ComputeBooleanLibrary_1.nand.apply(void 0, __spreadArrays([this], input));
    };
    ComputeBooleanNode.prototype.nor = function () {
        var input = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            input[_i] = arguments[_i];
        }
        return ComputeBooleanLibrary_1.nor.apply(void 0, __spreadArrays([this], input));
    };
    ComputeBooleanNode.prototype.xnand = function () {
        var input = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            input[_i] = arguments[_i];
        }
        return ComputeBooleanLibrary_1.xnand.apply(void 0, __spreadArrays([this], input));
    };
    ComputeBooleanNode.prototype.xnor = function () {
        var input = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            input[_i] = arguments[_i];
        }
        return ComputeBooleanLibrary_1.xnor.apply(void 0, __spreadArrays([this], input));
    };
    ComputeBooleanNode.prototype.implies = function (x) {
        return ComputeBooleanLibrary_1.implies(this, x);
    };
    ComputeBooleanNode.prototype.equals = function (x) {
        return ComputeBooleanLibrary_1.equals(this, x);
    };
    ComputeBooleanNode.prototype.not = function () {
        return ComputeBooleanLibrary_1.not(this);
    };
    ComputeBooleanNode.prototype.isTrue = function () {
        return ComputeBooleanLibrary_1.isTrue(this);
    };
    ComputeBooleanNode.prototype.isFalse = function () {
        return ComputeBooleanLibrary_1.isFalse(this);
    };
    return ComputeBooleanNode;
}(core_1.ComputeApiNode));
exports.ComputeBooleanNode = ComputeBooleanNode;
